# version code 988
# Please fill out this stencil and submit using the provided submission script.

from matutil import *
from GF2 import one



## Problem 1
# Write each matrix as a list of row lists

echelon_form_1 = [[1,2,0,2,0],
                  [0,1,0,3,4],
                  [0,0,2,3,4],
                  [0,0,0,2,0],
                  [0,0,0,0,4]]

echelon_form_2 = [[0,4,3,4,4],
                  [0,0,4,2,0],
                  [0,0,0,0,1],
                  [0,0,0,0,0]]

echelon_form_3 = [[1,0,0,1],
                  [0,0,0,1],
                  [0,0,0,0]]

echelon_form_4 = [[1,0,0,0],
                  [0,1,0,0],
                  [0,0,0,0],
                  [0,0,0,0]]



def echelonize(rowlist):
   col_label_list = sorted(rowlist[0].D, key=hash)
   new_rowlist = []
   rows_left = set(range(len(rowlist)))
   for c in col_label_list:
     rows_with_nonzero = [r for r in rows_left if rowlist[r][c] != 0]
     if rows_with_nonzero != []:
       pivot = rows_with_nonzero[0]
       new_rowlist.append(rowlist[pivot])
       rows_left.remove(pivot)
       for r in rows_with_nonzero[1:]:
         multiplier = rowlist[r][c]/rowlist[pivot][c]
         rowlist[r] -= multiplier * rowlist[pivot]
   return new_rowlist


## Problem 2
def is_echelon(A):
    '''
    Input:
        - A: a list of row lists
    Output:
        - True if A is in echelon form
        - False otherwise
    Examples:
        >>> is_echelon([[1,1,1],[0,1,1],[0,0,1]])
        True
        >>> is_echelon([[0,1,1],[0,1,0],[0,0,1]])
        False
    '''
    #pass
    from vecutil import list2vec
    from vecutil import vec2list
    rowlist = [list2vec(v) for v in A]
    x = echelonize(rowlist)
    xlist = [vec2list(v) for v in x]
    if xlist == A: return True
    if xlist == []: return True
    if len(xlist) == 0: # unnecessary because of preceding line
      l = 1             # 
    else:
      l = len(xlist[0])
    xlist.append([0]*l)
    if xlist == A: return True
    return False



## Problem 3
# Give each answer as a list

echelon_form_vec_a = [1,0,3,0] 
echelon_form_vec_b = [-3,0,-2,3]
echelon_form_vec_c = [-5,0,2,0,2]



## Problem 4
# If a solution exists, give it as a list vector.
# If no solution exists, provide "None".

solving_with_echelon_form_a = None
solving_with_echelon_form_b = [21,0,2,0,0]



## Problem 5
def echelon_solve(rowlist, label_list, b):
    '''
    Input:
        - rowlist: a list of Vecs
        - label_list: a list of labels establishing an order on the domain of
                      Vecs in rowlist
        - b: a vector (represented as a list)
    Output:
        - Vec x such that rowlist * x is b
    >>> D = {'A','B','C','D','E'}
    >>> U_rows = [Vec(D, {'A':one, 'E':one}), Vec(D, {'B':one, 'E':one}), Vec(D,{'C':one})] 
    >>> b_list = [one,0,one]
    >>> cols = ['A', 'B', 'C', 'D', 'E']
    >>> echelon_solve(U_rows, cols, b_list)
    Vec({'B', 'C', 'A', 'D', 'E'},{'B': 0, 'C': one, 'A': one})
    '''
    #pass
    from vecutil import zero_vec
    from vec import Vec
    rl = list(rowlist)
    D = rl[0].D
    x = zero_vec(D)
    for i in reversed(range(len(rl))):
      if rl[i].f == {}: next
      for j in range(len(D)):
        if rl[i][label_list[j]] != 0:
          x[label_list[j]] = (b[i]-x*rl[i])/rl[i][label_list[j]]
          break
    return x


## Problem 6
#rowlist = [ ... ]    # Provide as a list of Vec instances
rowlist = [Vec({'D', 'C', 'B', 'A'},{'D': one, 'B': one, 'A': one}), Vec({'D', 'C', 'B', 'A'},{'B': one}), Vec({'D', 'C', 'B', 'A'},{'C': one}), Vec({'D', 'C', 'B', 'A'}, {'D': one})]
#label_list = [ ... ] # Provide as a list
label_list = ['A','B','C','D']
#b = [ ... ]          # Provide as a list
b = [one,one,0,0]




## Problem 7
null_space_rows_a = {...} # Put the row numbers of M from the PDF
null_space_rows_a = {3,4}



## Problem 8
#null_space_rows_b = {...}
null_space_rows_b = {4}



## Problem 9
# Write each vector as a list
closest_vector_1 = [1.6,3.2]
closest_vector_2 = [0,1,0]
closest_vector_3 = [3,2,1,-4]



## Problem 10
# Write each vector as a list

project_onto_1 = [2,0]
projection_orthogonal_1 = [0,1]

project_onto_2 = [-0.166666666666, -0.3333333333, 0.166666666]
projection_orthogonal_2 = [1.166666666667, 1.33333333333, 3.83333333333]

project_onto_3 = [1,1,4]
projection_orthogonal_3 = [0,0,0]



## Problem 11
#norm1 = ...
#norm2 = ...
#norm3 = ...

norm1 = 3
norm2 = 4
norm3 = 1
